package net.mcreator.moremobsandweapons.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsandweapons.entity.BasiliskEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class BasiliskRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(BasiliskEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelbasilisk(), 0.4f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_and_weapons:textures/basilisk.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelbasilisk extends EntityModel<Entity> {
		private final ModelRenderer body;
		private final ModelRenderer cube_r1;
		private final ModelRenderer cube_r2;
		private final ModelRenderer cube_r3;
		private final ModelRenderer cube_r4;
		private final ModelRenderer cube_r5;
		private final ModelRenderer cube_r6;
		private final ModelRenderer head;
		public Modelbasilisk() {
			textureWidth = 128;
			textureHeight = 128;
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 24.0F, 0.0F);
			body.setTextureOffset(23, 6).addBox(-6.0F, -6.0F, 0.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			body.setTextureOffset(23, 23).addBox(-6.0F, -7.0F, 36.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			body.setTextureOffset(0, 17).addBox(-6.0F, -6.0F, 11.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r1 = new ModelRenderer(this);
			cube_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r1);
			setRotationAngle(cube_r1, 0.6109F, 0.0F, 0.0F);
			cube_r1.setTextureOffset(0, 0).addBox(-6.0F, 6.0F, 19.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r2 = new ModelRenderer(this);
			cube_r2.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r2);
			setRotationAngle(cube_r2, 0.3491F, 0.0F, 0.0F);
			cube_r2.setTextureOffset(23, 23).addBox(-6.0F, 9.0F, 45.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r3 = new ModelRenderer(this);
			cube_r3.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r3);
			setRotationAngle(cube_r3, -0.6109F, 0.0F, 0.0F);
			cube_r3.setTextureOffset(23, 23).addBox(-6.0F, -28.0F, 18.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r4 = new ModelRenderer(this);
			cube_r4.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r4);
			setRotationAngle(cube_r4, -0.4363F, 0.0F, 0.0F);
			cube_r4.setTextureOffset(0, 34).addBox(-6.0F, -6.0F, -22.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r5 = new ModelRenderer(this);
			cube_r5.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r5);
			setRotationAngle(cube_r5, -0.8727F, 0.0F, 0.0F);
			cube_r5.setTextureOffset(23, 40).addBox(-6.0F, 4.0F, -33.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			cube_r6 = new ModelRenderer(this);
			cube_r6.setRotationPoint(0.0F, 0.0F, 0.0F);
			body.addChild(cube_r6);
			setRotationAngle(cube_r6, -0.3054F, 0.0F, 0.0F);
			cube_r6.setTextureOffset(46, 0).addBox(-6.0F, -6.0F, -11.0F, 6.0F, 6.0F, 11.0F, 0.0F, false);
			head = new ModelRenderer(this);
			head.setRotationPoint(0.0F, 4.0F, -7.0F);
			head.setTextureOffset(49, 17).addBox(-7.0F, -8.0F, -26.0F, 8.0F, 8.0F, 8.0F, 0.0F, false);
			head.setTextureOffset(46, 40).addBox(-7.0F, -4.0F, -30.0F, 8.0F, 4.0F, 4.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			head.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
		}
	}
}
