package net.mcreator.moremobsandweapons.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsandweapons.entity.CharmanderEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class CharmanderRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(CharmanderEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelcharmander(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_and_weapons:textures/charmander.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelcharmander extends EntityModel<Entity> {
		private final ModelRenderer head;
		private final ModelRenderer body;
		private final ModelRenderer leftleg;
		private final ModelRenderer rightleg;
		private final ModelRenderer leftarm;
		private final ModelRenderer rightarm;
		private final ModelRenderer tail;
		private final ModelRenderer tail2_r1;
		private final ModelRenderer tail1_r1;
		public Modelcharmander() {
			textureWidth = 64;
			textureHeight = 64;
			head = new ModelRenderer(this);
			head.setRotationPoint(-1.0F, 12.0F, -2.0F);
			head.setTextureOffset(0, 0).addBox(-3.0F, -6.0F, -3.0F, 6.0F, 6.0F, 6.0F, 0.0F, false);
			head.setTextureOffset(10, 23).addBox(-2.0F, -3.0F, -6.0F, 4.0F, 3.0F, 3.0F, 0.0F, false);
			body = new ModelRenderer(this);
			body.setRotationPoint(0.0F, 24.0F, 0.0F);
			body.setTextureOffset(0, 12).addBox(-4.0F, -12.0F, -4.0F, 6.0F, 7.0F, 3.0F, 0.0F, false);
			leftleg = new ModelRenderer(this);
			leftleg.setRotationPoint(0.0F, 19.0F, 0.0F);
			leftleg.setTextureOffset(21, 28).addBox(-1.0F, 0.0F, -4.0F, 3.0F, 5.0F, 3.0F, 0.0F, false);
			rightleg = new ModelRenderer(this);
			rightleg.setRotationPoint(-2.0F, 19.0F, -4.0F);
			rightleg.setTextureOffset(24, 20).addBox(-2.0F, 0.0F, 0.0F, 3.0F, 5.0F, 3.0F, 0.0F, false);
			leftarm = new ModelRenderer(this);
			leftarm.setRotationPoint(2.0F, 13.0F, 0.0F);
			leftarm.setTextureOffset(22, 9).addBox(0.0F, -1.0F, -4.0F, 2.0F, 7.0F, 3.0F, 0.0F, false);
			rightarm = new ModelRenderer(this);
			rightarm.setRotationPoint(-4.0F, 13.0F, 0.0F);
			rightarm.setTextureOffset(0, 22).addBox(-2.0F, -1.0F, -4.0F, 2.0F, 7.0F, 3.0F, 0.0F, false);
			tail = new ModelRenderer(this);
			tail.setRotationPoint(0.0F, 24.0F, 0.0F);
			tail.setTextureOffset(27, 0).addBox(-2.0F, -8.0F, 6.0F, 2.0F, 2.0F, 2.0F, 0.0F, false);
			tail2_r1 = new ModelRenderer(this);
			tail2_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			tail.addChild(tail2_r1);
			setRotationAngle(tail2_r1, 0.6109F, 0.0F, 0.0F);
			tail2_r1.setTextureOffset(13, 17).addBox(-2.0F, -2.0F, 4.0F, 2.0F, 1.0F, 5.0F, 0.0F, false);
			tail1_r1 = new ModelRenderer(this);
			tail1_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			tail.addChild(tail1_r1);
			setRotationAngle(tail1_r1, -0.5236F, 0.0F, 0.0F);
			tail1_r1.setTextureOffset(18, 0).addBox(-2.0F, -5.0F, -4.0F, 2.0F, 1.0F, 5.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			head.render(matrixStack, buffer, packedLight, packedOverlay);
			body.render(matrixStack, buffer, packedLight, packedOverlay);
			leftleg.render(matrixStack, buffer, packedLight, packedOverlay);
			rightleg.render(matrixStack, buffer, packedLight, packedOverlay);
			leftarm.render(matrixStack, buffer, packedLight, packedOverlay);
			rightarm.render(matrixStack, buffer, packedLight, packedOverlay);
			tail.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.rightleg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.rightarm.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.leftleg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.leftarm.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
		}
	}
}
