package net.mcreator.moremobsandweapons.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsandweapons.entity.ChimeraEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class ChimeraRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(ChimeraEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelchimera(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_and_weapons:textures/chimera.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelchimera extends EntityModel<Entity> {
		private final ModelRenderer head;
		private final ModelRenderer body;
		private final ModelRenderer upperBody;
		private final ModelRenderer leg0;
		private final ModelRenderer leg1;
		private final ModelRenderer leg2;
		private final ModelRenderer leg3;
		private final ModelRenderer tail;
		private final ModelRenderer tailmouth_r1;
		private final ModelRenderer tail3_r1;
		private final ModelRenderer tail2_r1;
		private final ModelRenderer tail_r1;
		private final ModelRenderer wingleft;
		private final ModelRenderer wing2_r1;
		private final ModelRenderer wing1_r1;
		private final ModelRenderer wingright;
		private final ModelRenderer wing2_r2;
		private final ModelRenderer wing1_r2;
		public Modelchimera() {
			textureWidth = 64;
			textureHeight = 64;
			head = new ModelRenderer(this);
			head.setRotationPoint(1.0F, 13.5F, -7.0F);
			head.setTextureOffset(24, 26).addBox(-3.0F, -3.0F, -2.0F, 6.0F, 6.0F, 4.0F, 0.0F, false);
			head.setTextureOffset(0, 3).addBox(1.0F, -5.0F, 0.0F, 2.0F, 2.0F, 1.0F, 0.0F, false);
			head.setTextureOffset(0, 0).addBox(-3.0F, -5.0F, 0.0F, 2.0F, 2.0F, 1.0F, 0.0F, false);
			head.setTextureOffset(25, 0).addBox(-1.5F, -0.02F, -5.0F, 3.0F, 3.0F, 4.0F, 0.0F, false);
			body = new ModelRenderer(this);
			body.setRotationPoint(-1.0F, 0.5F, 9.0F);
			head.addChild(body);
			body.setTextureOffset(0, 15).addBox(-3.0F, -5.0F, -10.0F, 8.0F, 9.0F, 6.0F, 0.0F, false);
			upperBody = new ModelRenderer(this);
			upperBody.setRotationPoint(1.0F, 14.0F, 2.0F);
			upperBody.setTextureOffset(0, 0).addBox(-3.0F, -3.0F, -5.0F, 6.0F, 6.0F, 9.0F, 0.0F, false);
			leg0 = new ModelRenderer(this);
			leg0.setRotationPoint(2.5F, 16.0F, 7.0F);
			leg0.setTextureOffset(8, 40).addBox(-1.0F, 0.0F, -4.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			leg1 = new ModelRenderer(this);
			leg1.setRotationPoint(-0.5F, 16.0F, 7.0F);
			leg1.setTextureOffset(0, 40).addBox(-1.0F, 0.0F, -4.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			leg2 = new ModelRenderer(this);
			leg2.setRotationPoint(2.5F, 16.0F, -4.0F);
			leg2.setTextureOffset(32, 36).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			leg3 = new ModelRenderer(this);
			leg3.setRotationPoint(-0.5F, 16.0F, -4.0F);
			leg3.setTextureOffset(24, 36).addBox(-1.0F, 0.0F, -1.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			tail = new ModelRenderer(this);
			tail.setRotationPoint(1.0F, 12.0F, 8.0F);
			tailmouth_r1 = new ModelRenderer(this);
			tailmouth_r1.setRotationPoint(-1.0F, 12.0F, -8.0F);
			tail.addChild(tailmouth_r1);
			setRotationAngle(tailmouth_r1, 1.5708F, 0.0F, 0.0F);
			tailmouth_r1.setTextureOffset(28, 21).addBox(-1.0F, -14.0F, 25.0F, 4.0F, 2.0F, 2.0F, 0.0F, false);
			tailmouth_r1.setTextureOffset(22, 15).addBox(-1.0F, -12.0F, 25.0F, 4.0F, 3.0F, 3.0F, 0.0F, false);
			tailmouth_r1.setTextureOffset(0, 30).addBox(0.0F, -9.0F, 25.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			tail3_r1 = new ModelRenderer(this);
			tail3_r1.setRotationPoint(-1.0F, 12.0F, -8.0F);
			tail.addChild(tail3_r1);
			setRotationAngle(tail3_r1, 0.8727F, 0.0F, 0.0F);
			tail3_r1.setTextureOffset(8, 30).addBox(0.0F, -18.0F, 18.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			tail2_r1 = new ModelRenderer(this);
			tail2_r1.setRotationPoint(-1.0F, 12.0F, -8.0F);
			tail.addChild(tail2_r1);
			setRotationAngle(tail2_r1, 0.4363F, 0.0F, 0.0F);
			tail2_r1.setTextureOffset(16, 30).addBox(0.0F, -18.0F, 12.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			tail_r1 = new ModelRenderer(this);
			tail_r1.setRotationPoint(-1.0F, 12.0F, -8.0F);
			tail.addChild(tail_r1);
			setRotationAngle(tail_r1, -0.3491F, 0.0F, 0.0F);
			tail_r1.setTextureOffset(34, 7).addBox(0.0F, -17.0F, 1.0F, 2.0F, 8.0F, 2.0F, 0.0F, false);
			wingleft = new ModelRenderer(this);
			wingleft.setRotationPoint(0.0F, 24.0F, 0.0F);
			wing2_r1 = new ModelRenderer(this);
			wing2_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			wingleft.addChild(wing2_r1);
			setRotationAngle(wing2_r1, 0.0F, 0.0F, 0.4363F);
			wing2_r1.setTextureOffset(56, 0).addBox(-13.0F, -15.0F, -1.0F, 1.0F, 10.0F, 5.0F, 0.0F, false);
			wing1_r1 = new ModelRenderer(this);
			wing1_r1.setRotationPoint(0.0F, 0.0F, 0.0F);
			wingleft.addChild(wing1_r1);
			setRotationAngle(wing1_r1, 0.0F, 0.0F, -0.5236F);
			wing1_r1.setTextureOffset(56, 0).addBox(4.0F, -18.0F, -1.0F, 1.0F, 7.0F, 5.0F, 0.0F, false);
			wingright = new ModelRenderer(this);
			wingright.setRotationPoint(12.0F, 24.0F, 0.0F);
			wing2_r2 = new ModelRenderer(this);
			wing2_r2.setRotationPoint(0.0F, 0.0F, 0.0F);
			wingright.addChild(wing2_r2);
			setRotationAngle(wing2_r2, 0.0F, 0.0F, -0.4363F);
			wing2_r2.setTextureOffset(56, 0).addBox(3.0F, -20.0F, -1.0F, 1.0F, 10.0F, 5.0F, 0.0F, false);
			wing1_r2 = new ModelRenderer(this);
			wing1_r2.setRotationPoint(0.0F, 0.0F, 0.0F);
			wingright.addChild(wing1_r2);
			setRotationAngle(wing1_r2, 0.0F, 0.0F, 0.5236F);
			wing1_r2.setTextureOffset(56, 0).addBox(-14.0F, -14.0F, -1.0F, 1.0F, 7.0F, 5.0F, 0.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			head.render(matrixStack, buffer, packedLight, packedOverlay);
			upperBody.render(matrixStack, buffer, packedLight, packedOverlay);
			leg0.render(matrixStack, buffer, packedLight, packedOverlay);
			leg1.render(matrixStack, buffer, packedLight, packedOverlay);
			leg2.render(matrixStack, buffer, packedLight, packedOverlay);
			leg3.render(matrixStack, buffer, packedLight, packedOverlay);
			tail.render(matrixStack, buffer, packedLight, packedOverlay);
			wingleft.render(matrixStack, buffer, packedLight, packedOverlay);
			wingright.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.leg0.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.leg1.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
			this.leg2.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.leg3.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}
}
