package net.mcreator.moremobsandweapons.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsandweapons.entity.ElixirgolemEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class ElixirgolemRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(ElixirgolemEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelsnowgolem(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_and_weapons:textures/elixir_golem.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelsnowgolem extends EntityModel<Entity> {
		private final ModelRenderer piece2;
		private final ModelRenderer piece1;
		private final ModelRenderer head;
		private final ModelRenderer arm1;
		private final ModelRenderer arm2;
		public Modelsnowgolem() {
			textureWidth = 64;
			textureHeight = 64;
			piece2 = new ModelRenderer(this);
			piece2.setRotationPoint(0.0F, 24.0F, 0.0F);
			piece2.setTextureOffset(0, 36).addBox(-6.0F, -12.0F, -6.0F, 12.0F, 12.0F, 12.0F, -0.5F, false);
			piece1 = new ModelRenderer(this);
			piece1.setRotationPoint(0.0F, -11.0F, 0.0F);
			piece2.addChild(piece1);
			piece1.setTextureOffset(0, 16).addBox(-5.0F, -10.0F, -5.0F, 10.0F, 10.0F, 10.0F, -0.5F, false);
			head = new ModelRenderer(this);
			head.setRotationPoint(0.0F, -9.0F, 0.0F);
			piece1.addChild(head);
			head.setTextureOffset(0, 0).addBox(-4.0F, -8.0F, -4.0F, 8.0F, 8.0F, 8.0F, -0.5F, false);
			head.setTextureOffset(0, 0).addBox(-2.0F, -9.0F, -2.0F, 4.0F, 2.0F, 4.0F, 0.0F, false);
			head.setTextureOffset(0, 0).addBox(-1.0F, -10.0F, -1.0F, 2.0F, 1.0F, 2.0F, 0.0F, false);
			arm1 = new ModelRenderer(this);
			arm1.setRotationPoint(0.0F, -7.0F, 0.0F);
			piece1.addChild(arm1);
			setRotationAngle(arm1, 0.0F, 0.0F, 0.7854F);
			arm1.setTextureOffset(32, 0).addBox(1.0F, -6.0F, -2.0F, 12.0F, 4.0F, 4.0F, -0.5F, false);
			arm2 = new ModelRenderer(this);
			arm2.setRotationPoint(0.0F, -7.0F, 0.0F);
			piece1.addChild(arm2);
			setRotationAngle(arm2, 0.0F, 0.0F, 2.3562F);
			arm2.setTextureOffset(32, 0).addBox(1.0F, 2.0F, -1.0F, 12.0F, 4.0F, 4.0F, -0.5F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			piece2.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.head.rotateAngleX = f4 / (180F / (float) Math.PI);
		}
	}
}
