package net.mcreator.moremobsandweapons.entity.renderer;

import net.minecraftforge.fml.client.registry.RenderingRegistry;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.util.math.MathHelper;
import net.minecraft.util.ResourceLocation;
import net.minecraft.entity.Entity;
import net.minecraft.client.renderer.model.ModelRenderer;
import net.minecraft.client.renderer.entity.model.EntityModel;
import net.minecraft.client.renderer.entity.MobRenderer;

import net.mcreator.moremobsandweapons.entity.OrcEntity;

import com.mojang.blaze3d.vertex.IVertexBuilder;
import com.mojang.blaze3d.matrix.MatrixStack;

@OnlyIn(Dist.CLIENT)
public class OrcRenderer {
	public static class ModelRegisterHandler {
		@SubscribeEvent
		@OnlyIn(Dist.CLIENT)
		public void registerModels(ModelRegistryEvent event) {
			RenderingRegistry.registerEntityRenderingHandler(OrcEntity.entity, renderManager -> {
				return new MobRenderer(renderManager, new Modelorc(), 0.5f) {
					@Override
					public ResourceLocation getEntityTexture(Entity entity) {
						return new ResourceLocation("more_mobs_and_weapons:textures/orc.png");
					}
				};
			});
		}
	}

	// Made with Blockbench 3.9.2
	// Exported for Minecraft version 1.15 - 1.16 with MCP mappings
	// Paste this class into your mod and generate all required imports
	public static class Modelorc extends EntityModel<Entity> {
		private final ModelRenderer orc;
		private final ModelRenderer Head;
		private final ModelRenderer Body;
		private final ModelRenderer RightArm;
		private final ModelRenderer LeftArm;
		private final ModelRenderer RightLeg;
		private final ModelRenderer LeftLeg;
		public Modelorc() {
			textureWidth = 64;
			textureHeight = 64;
			orc = new ModelRenderer(this);
			orc.setRotationPoint(0.0F, 24.0F, 0.0F);
			Head = new ModelRenderer(this);
			Head.setRotationPoint(0.0F, -32.0F, 0.0F);
			orc.addChild(Head);
			Head.setTextureOffset(0, 16).addBox(-4.0F, -10.0F, -4.0F, 8.0F, 8.0F, 8.0F, 2.0F, false);
			Head.setTextureOffset(0, 0).addBox(-4.0F, -10.0F, -4.0F, 8.0F, 8.0F, 8.0F, 2.5F, false);
			Body = new ModelRenderer(this);
			Body.setRotationPoint(0.0F, -24.0F, 0.0F);
			orc.addChild(Body);
			Body.setTextureOffset(28, 28).addBox(-4.0F, -6.0F, -2.0F, 8.0F, 12.0F, 4.0F, 2.0F, false);
			RightArm = new ModelRenderer(this);
			RightArm.setRotationPoint(-6.0F, -30.0F, 0.0F);
			orc.addChild(RightArm);
			RightArm.setTextureOffset(32, 0).addBox(-6.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, 2.0F, false);
			LeftArm = new ModelRenderer(this);
			LeftArm.setRotationPoint(6.0F, -30.0F, 0.0F);
			orc.addChild(LeftArm);
			LeftArm.setTextureOffset(0, 32).addBox(2.0F, 0.0F, -2.0F, 4.0F, 12.0F, 4.0F, 2.0F, false);
			RightLeg = new ModelRenderer(this);
			RightLeg.setRotationPoint(-2.9F, -16.0F, 0.0F);
			orc.addChild(RightLeg);
			RightLeg.setTextureOffset(44, 12).addBox(-2.0F, 2.0F, -2.0F, 3.0F, 12.0F, 4.0F, 2.0F, false);
			LeftLeg = new ModelRenderer(this);
			LeftLeg.setRotationPoint(3.9F, -16.0F, 0.0F);
			orc.addChild(LeftLeg);
			LeftLeg.setTextureOffset(16, 40).addBox(-2.0F, 2.0F, -2.0F, 3.0F, 12.0F, 4.0F, 2.0F, false);
		}

		@Override
		public void render(MatrixStack matrixStack, IVertexBuilder buffer, int packedLight, int packedOverlay, float red, float green, float blue,
				float alpha) {
			orc.render(matrixStack, buffer, packedLight, packedOverlay);
		}

		public void setRotationAngle(ModelRenderer modelRenderer, float x, float y, float z) {
			modelRenderer.rotateAngleX = x;
			modelRenderer.rotateAngleY = y;
			modelRenderer.rotateAngleZ = z;
		}

		public void setRotationAngles(Entity e, float f, float f1, float f2, float f3, float f4) {
			this.RightArm.rotateAngleX = MathHelper.cos(f * 0.6662F + (float) Math.PI) * f1;
			this.LeftLeg.rotateAngleX = MathHelper.cos(f * 1.0F) * -1.0F * f1;
			this.Head.rotateAngleY = f3 / (180F / (float) Math.PI);
			this.Head.rotateAngleX = f4 / (180F / (float) Math.PI);
			this.LeftArm.rotateAngleX = MathHelper.cos(f * 0.6662F) * f1;
			this.RightLeg.rotateAngleX = MathHelper.cos(f * 1.0F) * 1.0F * f1;
		}
	}
}
